#!/usr/bin/perl
use strict;
use warnings;
use Getopt::Long;
use File::Spec;
######Usser should modify the following path#######################

my $path_curf = File::Spec->rel2abs(__FILE__);
my ($vol, $dirs, $file) = File::Spec->splitpath($path_curf);
$dirs =~ s/bin//g;
chop($dirs);

my $I_TASSER_MR_dir = $dirs;

#####################################################################
my $operating_system=$^O;
unless ($operating_system eq "linux"){
    printf("Your operating system $operating_system is unsupported at this time\n");
    printf("Currently only Linux is supported\n");
    exit();
}

my ($targetname,$modelnum,$topN);
GetOptions('T:s' => \$targetname, 'N:s' => \$modelnum,'B:s' => \$topN);

if(!$targetname )
{
    printf "prepare4build.pl USAGE:\n";
    printf "Mandatory arguments:\n";
    printf "./prepare4build.pl -T Target_name\n";
    printf "Optional argments:\n";
    printf "      -N modelnum: modelnum is a number from 1 to 5,which represents the model number of the I-TASSER Models.(default:1)\n";
    printf "      -B topN: an integer from 1 to 20,which represents choosing the topN models according to the TFZ score in the MR models\n";
       
   exit();
}

if(!$modelnum){
   $modelnum=1;
}
if(!$topN){
   $topN=5;
}

my $target=$targetname; #target name


my $output="$I_TASSER_MR_dir/output";
my $MRESULT_dir="$output/MRESULT/$target/model$modelnum";
my $MRDataset_dir="$output/MRDataset/$target/model$modelnum";

my @ss=glob "$MRESULT_dir/*";
my %map1;
my %map2;
my %map3;
my %map4;
my %map5;
foreach my $s(@ss)
{
  my $Rworks;
  my $Rfrees;
  my $Rworkf;
  my $Rfreef;
  my $llg;
  my $tfz;
  my $e1;
  my $e2;
  my $e3;
  my $x;
  my $y;
  my $z;
  my @model=glob "$s/AutoMR*";
  foreach my $mol(@model){
#    printf "$mol\n";
    if(-e "$mol/MR.1.pdb")
    {
       
       my @tem2;
          @tem2=glob "$mol/*model*";      
         # print "$mol#########"; 
          my @ta=split('/',$tem2[0]);
          my $targetname=$ta[-4];
          my $job_num=$ta[-3];
          my $auto_run_num=$ta[-2];
          my $cutmodel_num=$ta[-1];
          my $model_id="$job_num#$auto_run_num";
         #read rmsd of cutmodel
         
       open(RD,"<$mol/MR.1.pdb");
       while (my $line=<RD>)
       {
         if ($line=~ /Log-Likelihood/)
         {
            $line=~ /\S+\s+\S+\s+\S+\s+(\S+)*/;
            $llg=$1;
         }
         if($line=~ /TFZ=/)
         {
           $line=~ /REMARK  RFZ=\S+ TFZ=(\S+) PAK=.*/;          
            $tfz=$1;
	   # print("$tfz==============\n");
	 }
         if($line=~ /EULER/)
         {
            $line=~ /.*EULER\s+(\S+)\s+(\S+)\s+(\S+)\s+\S+\s+(\S+)\s+(\S+)\s+(\S+).*/;
            $e1=$1;
            $e2=$2;
            $e3=$3;
            $x=$4;
            $y=$5;
            $z=$6;
         }
       }

             $Rworks=0.0;
             $Rfrees=0.0;
         
             $Rworkf=0.0;
             $Rfreef=0.0;
             $map1{$model_id}=$tfz;
  $map5{$model_id}="$job_num\t$auto_run_num/$cutmodel_num\t$Rworks\t$Rworkf\t$Rfrees\t$Rfreef\t$e1\t$e2\t$e3\t$x\t$y\t$z\t$llg\t$tfz";
 #$map2{$model_id}="$job_num\t$auto_run_num/$cutmodel_num\t$Rworks\t$Rworkf\t$Rfrees\t$Rfreef\t$e1\t$e2\t$e3\t$x\t$y\t$z\t$llg\t$tfz";

    }
    if(-e "$mol/MR.1_refine_001.log")
    {
       my @tem2;
      
          @tem2=glob "$mol/*model*";      
         # print "$mol#########"; 
          my @ta=split('/',$tem2[0]);
          my $targetname=$ta[-4];
          my $job_num=$ta[-3];
          my $auto_run_num=$ta[-2];
          my $cutmodel_num=$ta[-1];
          my $model_id="$job_num#$auto_run_num";
         #read rmsd of cutmodel
         open (RD,"<$mol/MR.1_refine_001.log");
         while(my $line=<RD>)
         {
            if(substr($line,0,12) eq 'Start R-work')
            {
              $line=~ /.*=\s+(\S+)\s+\S+\s\S\s(\S+)/;
              $Rworks=$1;
              $Rfrees=$2;
    
             }
           if(substr($line,0,12) eq 'Final R-work')
          {
             $line=~ /.*=\s+(\S+)\s+\S+\s\S\s(\S+)/;
             $Rworkf=$1;
             $Rfreef=$2;
             $map1{$model_id}=$tfz;
             $map2{$model_id}=
         "$targetname\t$job_num\t$auto_run_num\t$cutmodel_num\t$Rworks\t$Rworkf\t$Rfrees\t$Rfreef\t$e1\t$e2\t$e3\t$x\t$y\t$z\t$llg\t$tfz";
         
             $map3{$model_id}=$Rfreef;
             $map4{$model_id}=$Rfrees;
  $map5{$model_id}="$job_num\t$auto_run_num/$cutmodel_num\t$Rworks\t$Rworkf\t$Rfrees\t$Rfreef\t$e1\t$e2\t$e3\t$x\t$y\t$z\t$llg\t$tfz";
          }
         }
         close(RD);
       }
    }


}

my @keys= sort{$map1{$a}<=>$map1{$b}} keys %map1;
open(WRGOOD,">$MRESULT_dir/mgoodfor_build_f.txt");
 my $nm=1;
my $INDEX=$#keys-$topN ;
  $INDEX=0 if ($INDEX<0);
 for(my $i=$#keys;$i>$INDEX-1;$i--){
  
  if($map5{$keys[$i]}=~ /\t\S+\/(\S+)\_ed.pdb.*/){
  my $smodel=$1;
  #  print"$smodel\n";
   $smodel.=".pdb";
  `cp $MRDataset_dir/$smodel $MRESULT_dir/Search-$target-$nm.pdb`;
  $nm++;
  }
  printf WRGOOD "$map5{$keys[$i]}\n";
 # }  
  last if($i==0); 
 }
close(WRGOOD);

open(WR,">$MRESULT_dir/mphaserresult.txt");
 for(my $i=$#keys;$i>$INDEX-1;$i--){
 
  if(%map2){
  printf WR "$map2{$keys[$i]}\n" ;
  }
  last if($i==0); 
 }
close(WR);
